"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var DecoratorSpec = require("../spec/decorator");
var errors_1 = require("../spec/errors");
exports.AccountDecorators = new /** @class */ (function (_super) {
    __extends(class_1, _super);
    function class_1() {
        var _this = _super.call(this) || this;
        _this.implement("WithAccount", function (context, option, pass) {
            if (context.req.headers["x-auth-token"]) {
                var token = context.req.headers["x-auth-token"];
                context.services.AuthenticationService.getTokenInfo({ token: token }, function (err, info) {
                    if (err) {
                        context.error(new errors_1.Errors.Forbidden);
                        return;
                    }
                    context.services.AccountService.get(info.account.id, function (err, account) {
                        if (err) {
                            context.error(new errors_1.Errors.Forbidden("Can't find existing account"));
                            return;
                        }
                        // Still set account in this case.
                        // But we respect token more then session.account.
                        context.req.session.account = account;
                        context.info.account = account;
                        pass();
                    });
                });
            }
            else {
                if (!context.req.session || !context.req.session.account) {
                    context.error(new errors_1.Errors.Forbidden);
                    return;
                }
                var id = context.req.session.account.id;
                context.services.AccountService.get(id, function (err, account) {
                    if (err) {
                        context.error(new errors_1.Errors.Forbidden("Can't find existing account"));
                        return;
                    }
                    context.req.session.account = account;
                    context.info.account = account;
                    pass();
                });
            }
        });
        return _this;
    }
    return class_1;
}(DecoratorSpec.AccountDecorators));
//# sourceMappingURL=account.js.map