"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Leaf = require("leaf-ts");
var UploadService = /** @class */ (function (_super) {
    __extends(UploadService, _super);
    function UploadService(settings) {
        var _this = _super.call(this, {
            upload: {
                root: "192.168.0.220:25109"
            }
        }, settings) || this;
        _this.name = "UploadService";
        return _this;
    }
    UploadService.prototype.upload = function (file, callback) {
        var formData = new FormData();
        formData.append("file", file);
        var xhr = new XMLHttpRequest();
        var url = this.settings.upload.root + "/upload";
        // alert(url)
        xhr.open("POST", url, true);
        xhr.onload = function () {
            var text = xhr.responseText;
            var data;
            try {
                data = JSON.parse(text);
            }
            catch (e) {
                callback(new Error("Invalid server response" + text));
                return;
            }
            if (data.state) {
                callback(null, data.data);
            }
            else {
                callback(new Error(JSON.stringify(data.error)));
            }
        };
        xhr.onerror = function (e) {
            alert(e.message);
            alert("ERROR?" + JSON.stringify(e));
            callback(new Error("Fail to upload"));
        };
        xhr.send(formData);
    };
    return UploadService;
}(Leaf.Service));
exports.UploadService = UploadService;
//# sourceMappingURL=uploadService.js.map