import { APIRoute } from "./route";
import { Service } from "./service";
export interface RouteDecorator<TThis = any> {
    (this: TThis, obj: any, name: string, descriptor: TypedPropertyDescriptor<RouteInterface<TThis>>): void;
}
export interface RouteInterface<TThis = any> {
    (this: TThis, context: TThis, ...args: any[]): void;
}
export interface RouteDecoratorFactory<TThis = any, TOption = null> {
    (option: TOption): RouteDecorator<TThis>;
}
export declare namespace RouteDecoratorFactory {
    function from<TThis = any, TOption = null>(guard: GuardFunction<TThis, TOption>): RouteDecoratorFactory<TThis, TOption>;
}
export interface GuardFunction<TThis = any, TOption = any> {
    (this: TThis, context: TThis, option: TOption, pass: () => void): void;
}
export interface FakeService<TServices> extends Service {
    services: TServices;
}
export declare class RouteDecorators<TSpecs extends RouteDecoratorSpecs = any> {
    spec: TSpecs;
    constructor(spec: TSpecs);
    private decs;
    implement<K extends keyof TSpecs>(name: K, guard: GuardFunction<APIRoute<TSpecs[K]["return"], Error, FakeService<TSpecs[K]["services"]>> & TSpecs[K], TSpecs[K]["option"]>): void;
    decorate<K extends keyof TSpecs>(name: K, option?: TSpecs[K]["option"]): RouteDecorator<any>;
}
export declare abstract class RouteDecoratorSpec {
    params?: any;
    services?: any;
    option?: any;
    return?: any;
}
export interface RouteDecoratorSpecs {
    [name: string]: RouteDecoratorSpec;
}
