"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RouteDecoratorFactory;
(function (RouteDecoratorFactory) {
    function from(guard) {
        return function (option) {
            return function (obj, name, descriptor) {
                var orig = descriptor.value;
                descriptor.value = function (context) {
                    var _this = this;
                    guard.call(this, this, option, function () {
                        orig.call(_this, _this);
                    });
                };
            };
        };
    }
    RouteDecoratorFactory.from = from;
})(RouteDecoratorFactory = exports.RouteDecoratorFactory || (exports.RouteDecoratorFactory = {}));
var RouteDecorators = /** @class */ (function () {
    function RouteDecorators(spec) {
        this.spec = spec;
        this.decs = {};
    }
    RouteDecorators.prototype.implement = function (name, guard) {
        if (this.decs[name]) {
            throw new Error("Duplication implementation of decorator " + name);
        }
        this.decs[name] = RouteDecoratorFactory.from(guard);
    };
    RouteDecorators.prototype.decorate = function (name, option) {
        var factory = this.decs[name];
        if (!factory) {
            throw new Error("Implementation of decorator " + name + " not found");
        }
        return factory(option);
    };
    return RouteDecorators;
}());
exports.RouteDecorators = RouteDecorators;
var RouteDecoratorSpec = /** @class */ (function () {
    function RouteDecoratorSpec() {
    }
    return RouteDecoratorSpec;
}());
exports.RouteDecoratorSpec = RouteDecoratorSpec;
//# sourceMappingURL=decorator.js.map