import { DependencyManager } from "./dependency";
import "source-map-support/register";
export declare type ServiceMatcher = string | RegExp;
export declare class ServiceContext<TServices extends {
    [name: string]: Service;
} = {}> {
    private settings;
    private BuiltInServiceInstances;
    constructor(settings?: {});
    services: TServices;
    dependencyManager: DependencyManager;
    register(s: Service): void;
    supportedLoadExtnames: string[];
    loadServices(path: string): void;
    loadService(path: string): void;
    private isServiceConstructor(obj);
    maxInitializingTimeout: number;
    isSetup: boolean;
    private finishSetup;
    setup(finish?: (err?: Error) => void): void;
    private logInitialized(name);
}
export declare abstract class Service<TSettings = any> {
    readonly _defaultSettings: TSettings;
    abstract name: string;
    abstract services: any;
    dependencies: ServiceMatcher[];
    befores: ServiceMatcher[];
    isInitialized: boolean;
    initialize(done?: (err?: Error) => void): void;
    constructor(_defaultSettings: TSettings, settings?: TSettings);
    settings: TSettings;
    protected buildOption(df: any, config: any): void;
}
