"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var route_1 = require("../lib/route");
var fs = require("fs");
var pathModule = require("path");
var Leaf = require("leaf-ts");
var DefaultPageService = /** @class */ (function (_super) {
    __extends(DefaultPageService, _super);
    function DefaultPageService(option) {
        if (option === void 0) { option = {}; }
        var _this = _super.call(this) || this;
        _this.name = "page.default";
        _this.prefix = "";
        _this.dependencies = [/api\..+/ig, /page\..+/ig, "ExpressService"];
        _this.defaultPageCode = 200;
        _this.defaultHTML = "";
        var config = Leaf.Util.buildOption({
            default: null
        }, option.page || {});
        _this.defaultPagePath = config.default;
        return _this;
    }
    DefaultPageService.prototype.initialize = function () {
        this.addRoutes(module.exports);
        this.installTo(this.services.ExpressService.server);
    };
    DefaultPageService.prototype.clearDefaultHTMLCache = function () {
        this.defaultHTML = "";
    };
    DefaultPageService.prototype.generateDefaultHTMLContent = function (callback) {
        var html;
        if (!this.defaultPagePath) {
            html = "No default content.";
        }
        else {
            var path = pathModule.join(this.defaultPagePath);
            try {
                html = fs.readFileSync(path, "utf8");
                this.defaultHTML = html;
            }
            catch (e) {
                callback(e);
                return;
            }
        }
        callback(null, html);
    };
    DefaultPageService.prototype.getDefaultPage = function (callback) {
        var _this = this;
        if (this.defaultHTML) {
            callback(null, this.defaultHTML);
            return;
        }
        this.generateDefaultHTMLContent(function (err, html) {
            if (err) {
                callback(err);
                return;
            }
            _this.defaultHTML = html;
            callback(null, html);
        });
    };
    DefaultPageService.prototype.setDefaultHTMLContent = function (html) {
        this.defaultHTML = html;
    };
    return DefaultPageService;
}(route_1.RouteService));
exports.DefaultPageService = DefaultPageService;
var DefaultPage = /** @class */ (function (_super) {
    __extends(DefaultPage, _super);
    function DefaultPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.path = "*";
        return _this;
    }
    DefaultPage.prototype.handle = function () {
        var _this = this;
        this.service.getDefaultPage(function (err, html) {
            if (err) {
                _this.res.status(503);
                _this.html("ERROR" + err.toString());
                return;
            }
            _this.res.status(_this.service.defaultPageCode);
            _this.html(html);
        });
    };
    return DefaultPage;
}(route_1.PageRoute));
exports.DefaultPage = DefaultPage;
//# sourceMappingURL=page.default.js.map