import { Service } from "../lib/service";
import * as ServiceSpec from "../spec/service";
import * as mongodb from "mongodb";
import * as Leaf from "leaf-ts";
export declare type Callback<T> = (err?: Error, result?: T) => void;
export declare const Errors: {
    NotFound: Leaf.CustomErrorConstructor<{}>;
    UnknownError: Leaf.CustomErrorConstructor<{}>;
    DBError: Leaf.CustomErrorConstructor<{}>;
    AlreadyExists: Leaf.CustomErrorConstructor<{}>;
    InvalidParameter: Leaf.CustomErrorConstructor<{}>;
    NameAlreadyExists: Leaf.CustomErrorConstructor<{}>;
    EmailAlreadyExists: Leaf.CustomErrorConstructor<{}>;
};
export declare class AccountService<TAccountDefinition extends AccountService.AccountDefinition = AccountService.AccountDefinition> extends Service {
    readonly name: string;
    protected collectionName: string;
    readonly dependencies: string[];
    services: ServiceSpec.AllServices;
    accountCollection: mongodb.Collection;
    initialize(done: any): void;
    create(option: {
        account: TAccountDefinition;
    }, callback: Callback<TAccountDefinition>): void;
    createFromAuthentication(option: {
        authentication: AuthenticationService.AuthenticationData<any, any>;
        id?: string;
        name?: string;
        //displayName?: string;
        props?: TAccountDefinition["props"];
        role?: TAccountDefinition["role"];
    }, callback: Callback<TAccountDefinition>): void;
    get(id: string, callback: Callback<TAccountDefinition>): void;
    gets(ids: string[], callback: Callback<TAccountDefinition[]>): void;
    update(option: {
        account: TAccountDefinition;
        mongoUpdates?: any;
    }, callback: Callback<TAccountDefinition>): void;
}
