"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ServiceSpec = require("../spec/service");
var Leaf = require("leaf-ts");
exports.Errors = Leaf.ErrorDoc.build({
    InvalidParameter: {},
    InvalidState: {},
    InnerError: {},
    NotFound: {},
    Failed: {},
    AlreadyExists: {}
});
var EndlessService = /** @class */ (function (_super) {
    __extends(EndlessService, _super);
    function EndlessService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EndlessService.prototype.query = function (option, callback) {
        var col = option.collection;
        var offset = option.offset || 0;
        var count = option.count || this.settings.endless.count;
        col.find(option.criteria).skip(offset).limit(count).toArray(callback);
    };
    return EndlessService;
}(ServiceSpec.EndlessService));
exports.EndlessService = EndlessService;
//# sourceMappingURL=endlessService.js.map