import * as mongodb from "mongodb"
import * as ServiceSpec from "../spec/service"
import * as Leaf from "leaf-ts"
import * as asyncModule from "async"
import * as uuid from "uuid"
export const Errors = Leaf.ErrorDoc.build({
    InvalidParameter: {},
    InvalidState: {},
    InnerError: {},
    NotFound: {},
    Failed: {},
    AlreadyExists: {}
})

export class EndlessService extends ServiceSpec.EndlessService {
    query<K, T = any>(option: EndlessService.EndlessQuery<T> & {
        collection: mongodb.Collection
    }, callback: Callback<K[]>) {
        let col = option.collection
        let offset = option.offset || 0
        let count = option.count || this.settings.endless.count
        col.find(option.criteria as any).skip(offset).limit(count).toArray(callback)
    }
}
