/// <reference types="express" />
import { Service } from "../service";
import * as express from "express";
import { MongodbService } from "./mongodbService";
export declare class ExpressService<TConfig extends {
    http?: {
        port?: number;
        host?: string;
        offline?: boolean;
    };
    staticResources?: {
        path: string;
        route: string;
    }[];
} = any> extends Service<TConfig> {
    name: "ExpressService";
    dependencies: string[];
    services: {
        MongodbService: MongodbService;
    };
    server: express.Application;
    constructor(config: TConfig);
    offline: boolean;
    private host;
    private port;
    private httpServer;
    initialize(done: any): void;
    initHttp(callback: Function): void;
    asBuiltIn(): void;
    private staticPathes;
    static(path: string, route?: string): void;
    private useStatic(info);
}
