import { Service } from "../service";
import { MongodbService } from "./mongodbService";
import * as mongodb from "mongodb";
import * as Leaf from "leaf-ts";
export declare type Callback<T = any, E extends Error = Error> = (e?: E, result?: T) => void;
export declare const Errors: {
    UnknownError: Leaf.CustomErrorConstructor<{}>;
    NotFound: Leaf.CustomErrorConstructor<{}>;
    InvalidParameter: Leaf.CustomErrorConstructor<{}>;
};
export declare class IncrementalIdService extends Service {
    name: string;
    dependencies: string[];
    services: {
        MongodbService: MongodbService;
    };
    constructor();
    protected collectionName: string;
    protected incrementalIdCollection: mongodb.Collection;
    readonly defaultOffset: number;
    initialize(): void;
    availableItems: {};
    ensure(option: {
        name: string;
        offset: number;
    }, callback: Callback<void>): void;
    offset(option: {
        name: string;
        offset: number;
    }, callback: Callback<void>): void;
    next(option: {
        name: string;
        count?: number;
    }, callback: Callback<number>): void;
}
