"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ServiceSpec = require("../spec/service");
var errors_1 = require("../spec/errors");
var KeyValueStorage = /** @class */ (function (_super) {
    __extends(KeyValueStorage, _super);
    function KeyValueStorage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    KeyValueStorage.prototype.initialize = function (done) {
        this.collection = this.services.MongodbService.db.collection(this.settings.kvs.collection);
        this.collection.createIndex({
            key: 1
        }, {
            unique: true
        }, done);
    };
    KeyValueStorage.prototype.set = function (k, v, callback) {
        this.collection.findOneAndUpdate({ key: k }, {
            key: k,
            value: v
        }, {
            upsert: true
        }, function (err, result) {
            callback(err);
        });
    };
    KeyValueStorage.prototype.get = function (k, callback) {
        this.collection.findOne({
            key: k
        }, function (err, value) {
            if (err || !value) {
                callback(new errors_1.Errors.NotFound());
                return;
            }
            callback(null, value.value);
        });
    };
    return KeyValueStorage;
}(ServiceSpec.KeyValueStorage));
exports.KeyValueStorage = KeyValueStorage;
//# sourceMappingURL=keyValueStorage.js.map