import { Service } from "../service";
import * as Leaf from "leaf-ts";
export declare const Errors: Leaf.ErrorsOf<{
    InvalidLegacyUsername: {};
    LegacyUsernameTooShort: {};
    LegacyUsernameTooLong: {};
    PasswordTooShort: {};
    PasswordTooLong: {};
    EmailTooLong: {};
    InvalidEmail: {};
    InvalidDisplayName: {};
    DisplayNameTooShort: {};
    DisplayNameTooLong: {};
    InvalidPassword: {};
    LegacyUsernameRequired: {};
    PasswordRequired: {};
    EmailRequired: {};
}>;
export declare type LegacyUser = LegacyUserDefinitionService.LegacyUser;
export declare class LegacyUserDefinitionService<TLegacyUser extends LegacyUserDefinitionService.LegacyUser> extends Service {
    readonly name: string;
    services: null;
    LegacyUserPartialValidator: Leaf.Validator;
    LegacyUserValidator: Leaf.Validator<{
        [key: string]: any;
    }>;
}
export declare namespace LegacyUserDefinitionService {
    interface LegacyUser {
        id?: string;
        legacyUsername: string;
        displayName?: string;
        passwordHash?: string;
        password?: string;
        email: string;
        createAt?: number;
    }
}
export interface LegacyUserValidationConfig {
    minLegacyUsernameLength: number;
    maxLegacyUsernameLength: number;
    minDisplayNameLength: number;
    maxDisplayNameLength: number;
    minPasswordLength: number;
    maxPasswordLength: number;
    maxEmailLength: number;
}
export declare const DefaultLegacyUserValidationConfig: LegacyUserValidationConfig;
export declare function GenerateLegacyUserValidator(config?: LegacyUserValidationConfig): Leaf.Validator<{
    [key: string]: any;
}>;
