"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ServiceSpec = require("../spec/service");
var sgMail = require("@sendgrid/mail");
var MailService = /** @class */ (function (_super) {
    __extends(MailService, _super);
    function MailService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = "MailService";
        return _this;
    }
    MailService.prototype.send = function (option, callback) {
        this.sendBySendgrid(option, callback);
    };
    MailService.prototype.sendBySendgrid = function (option, callback) {
        sgMail.setApiKey(this.settings.mail.sendgrid.apiKey);
        var html = option.mail.content || "";
        var mail = {
            to: option.to,
            from: option.from,
            subject: option.mail.title,
            // by default we replace html tags to get fallback text
            text: option.mail.fallbackText || html.replace(/<.*?>/g, ""),
            html: html
        };
        sgMail.send(mail, function (err) {
            callback(err);
        });
    };
    return MailService;
}(ServiceSpec.MailService));
exports.MailService = MailService;
//# sourceMappingURL=mailService.js.map