"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ServiceSpec = require("../spec/service");
var fs = require("fs-extra");
var pathModule = require("path");
var PersistentService = /** @class */ (function (_super) {
    __extends(PersistentService, _super);
    function PersistentService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.storageName = "persistent.json";
        _this.storagePath = pathModule.join(_this.settings.persistent.storage, _this.storageName);
        _this.datas = {};
        _this.tracks = {};
        return _this;
    }
    PersistentService.prototype.initialize = function () {
        var _this = this;
        this.services.GracefulShutdownService.graceful({
            name: "persistent",
            timeout: 1000 * 30
        }, function (done) {
            _this.save();
            console.log("Persisted");
            done();
        });
        fs.mkdirpSync(this.settings.persistent.storage);
        this.storageName == this.settings.persistent.storageName || this.storageName;
        this.storagePath = pathModule.join(this.settings.persistent.storage, this.storageName);
        if (!fs.existsSync(this.storagePath)) {
            return;
        }
        try {
            this.datas = JSON.parse(fs.readFileSync(this.storagePath, "utf8"));
        }
        catch (e) {
            console.error("Fail to load broken persistent files");
            return;
        }
    };
    PersistentService.prototype.track = function (obj) {
        if (this.tracks[obj.name]) {
            console.error("Can't duplicate tracking " + obj.name);
            return false;
        }
        this.tracks[obj.name] = obj;
    };
    PersistentService.prototype.restore = function (obj) {
        var data = this.datas[obj.name];
        if (!data) {
            console.log("No restore for", obj.name);
            return false;
        }
        obj.fromJSON(data);
    };
    PersistentService.prototype.save = function () {
        for (var name_1 in this.tracks) {
            var obj = this.tracks[name_1];
            this.datas[name_1] = obj.toJSON();
        }
        fs.writeFileSync(this.storagePath, JSON.stringify(this.datas));
    };
    return PersistentService;
}(ServiceSpec.PersistentService));
exports.PersistentService = PersistentService;
//# sourceMappingURL=persistentService.js.map