/// <reference types="express-session" />
import { Service } from "../service";
import { MongodbService } from "./mongodbService";
import { ExpressService } from "./expressService";
import * as Session from "express-session";
export declare class RouteSessionService extends Service {
    name: "RouteSessionService";
    dependencies: ["ExpressService", "MongodbService"];
    services: {
        ExpressService: ExpressService;
        MongodbService: MongodbService;
    };
    asBuiltIn(): void;
    constructor(config?: {
        http?: {
            session?: {
                secret?: string;
                maxAge?: number;
                resave?: boolean;
                saveUninitialized?: boolean;
                store?: Session.Store;
            };
        };
    });
    private config;
    private defaultSecret;
    private defaultMaxAge;
    initialize(): void;
}
