"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../lib/service");
var ConnectMongo = require("connect-mongo");
var ExpressSession = require("express-session");
var MongoStore = ConnectMongo(ExpressSession);
var RouteSessionService = /** @class */ (function (_super) {
    __extends(RouteSessionService, _super);
    function RouteSessionService(settings) {
        var _this = _super.call(this, {
            http: {
                session: {
                    secret: null,
                    resave: false,
                    maxAge: null,
                    saveUninitialized: false
                }
            }
        }, settings) || this;
        _this.name = "RouteSessionService";
        _this.dependencies = ["ExpressService", "MongodbService"];
        _this.defaultSecret = "default-session-secret";
        // 31 day
        _this.defaultMaxAge = 1000 * 60 * 60 * 24 * 31;
        return _this;
    }
    RouteSessionService.prototype.asBuiltIn = function () {
        console.log("RouteService default use MongodbService and default secret.");
    };
    RouteSessionService.prototype.initialize = function () {
        var _a = this.settings.http.session, secret = _a.secret, resave = _a.resave, maxAge = _a.maxAge, saveUninitialized = _a.saveUninitialized;
        this.services.ExpressService.server.use(ExpressSession({
            secret: secret || this.defaultSecret,
            store: new MongoStore({ db: this.services.MongodbService.db, ttl: maxAge || this.defaultMaxAge }),
            resave: resave || false,
            saveUninitialized: saveUninitialized || false
        }));
    };
    return RouteSessionService;
}(service_1.Service));
exports.RouteSessionService = RouteSessionService;
//# sourceMappingURL=routeSessionService.js.map