/// <reference types="express" />
import * as Leaf from "leaf-ts";
import { Service } from "../service";
import * as express from "express";
export declare const Errors: {
    UploadError: Leaf.CustomErrorConstructor<{}>;
};
export declare namespace UploadService {
    type Settings = {
        upload: {
            temp: string;
            acceptedExtnames?: string[];
            maxSizeInMB?: number;
            route?: string;
        };
    };
}
export declare class UploadService extends Service<UploadService.Settings> {
    name: string;
    dependencies: string[];
    services: {
        ExpressService;
        BlobService;
    };
    constructor(settings: UploadService.Settings);
    error(res: express.Response, err: any): void;
    success(res: express.Response, data: any): void;
    initialize(): void;
    private createUploadHandler(middleware);
    private createMulterConfig();
}
