"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../lib/service");
var Leaf = require("leaf-ts");
var wxkit = require("wxkit");
var WechatPaymentService = /** @class */ (function (_super) {
    __extends(WechatPaymentService, _super);
    function WechatPaymentService(settings) {
        var _this = _super.call(this, {
            wechat: {
                payment: {
                    merchantId: null,
                    key: null,
                    notificationUrl: null,
                }
            }
        }, settings) || this;
        _this.settings = settings;
        _this.name = "WechatPaymentService";
        _this.dependencies = ["ExpressService", "RouteSessionService", "WechatService"];
        _this.befores = ["page.default"];
        var option = Leaf.Util.buildOption(settings.wechat, {});
        return _this;
    }
    WechatPaymentService.prototype.initialize = function () {
        this.client = this.services.WechatService.client;
        this.payment = new wxkit.WechatPaymentClient(this.client, {
            key: this.settings.wechat.payment.key,
            merchantId: this.settings.wechat.payment.merchantId,
            notificationUrl: this.settings.wechat.payment.notificationUrl
        });
    };
    return WechatPaymentService;
}(service_1.Service));
exports.WechatPaymentService = WechatPaymentService;
//# sourceMappingURL=wechatPaymentService.js.map