import { ExpressService } from "./expressService"
import { WechatService } from "./wechatService"
import { Service } from "../lib/service"
import * as Leaf from "leaf-ts"
import * as wxkit from "wxkit"

export class WechatPaymentService extends Service {
    readonly name = "WechatPaymentService"
    readonly dependencies = ["ExpressService", "RouteSessionService", "WechatService"]
    constructor(public settings: WechatPaymentService.Settings) {
        super({
            wechat: {
                payment: {
                    merchantId: null,
                    key: null,
                    notificationUrl: null,
                }
            }
        }, settings)
        let option = Leaf.Util.buildOption(settings.wechat, {})
    }
    initialize() {
        this.client = this.services.WechatService.client
        this.payment = new wxkit.WechatPaymentClient(this.client, {
            key: this.settings.wechat.payment.key,
            merchantId: this.settings.wechat.payment.merchantId,
            notificationUrl: this.settings.wechat.payment.notificationUrl
        })
    }
    services: {
        ExpressService: ExpressService
        WechatService: WechatService
    }
    befores = ["page.default"]
    client: wxkit.WechatClient
    payment: wxkit.WechatPaymentClient
}
