import { RouteDecoratorSpec, RouteDecorators } from "../lib/decorator"
import { AllServices } from "./service"

abstract class Inf extends RouteDecoratorSpec {
    services: AllServices
}
export const AccountDecoratorsSpec = {
    // obtain account in token/session
    WithAccount: new class extends Inf {
        info: {
            account: AccountService.Account
        }
        req: {
            session: {
                user: AccountService.Account
            }
        }
    },
}
export abstract class AccountDecorators extends RouteDecorators<typeof AccountDecoratorsSpec> {
    constructor() {
        super(AccountDecoratorsSpec)
    }
}
