import { RouteServiceTemplate, APIServiceSpec } from "../lib/route";
import * as ServiceSpec from "./service";
export declare abstract class RouteService<T extends APIServiceSpec> extends RouteServiceTemplate<T> {
    dependencies: string[];
    services: ServiceSpec.AllServices;
}
export declare namespace AccountAPIService {
    const prefix = "/api/";
    const name = "api.account";
    const API: {
        getCurrentAccount: {
            readonly method: "POST";
            readonly path: "account/me/GET";
            info: {
                account: AccountService.AccountDefinition<any, string>;
            };
            return: AccountService.AccountDefinition<any, string>;
            error: Error;
        };
        webLoginStandard: {
            readonly method: "POST";
            readonly path: "account/authentication/standard/GET";
            body: {
                login: string;
                password: string;
            };
            return: {
                account: AccountService.AccountDefinition<any, string>;
            };
            error: Error;
        };
        getTokenStandard: {
            readonly method: "POST";
            readonly path: "account/authentication/standard/token/GET";
            body: {
                login: string;
                password: string;
            };
            return: {
                account: AccountService.AccountDefinition<any, string>;
                token: string;
            };
            error: Error;
        };
        registerStandard: {
            readonly method: "POST";
            readonly path: "account/authentication/standard";
            body: {
                name: string;
                password: string;
                email: string;
            };
            return: {
                account: AccountService.AccountDefinition<any, string>;
            };
            error: Error;
        };
    };
}
export declare abstract class AccountAPIServiceSpec extends RouteService<typeof AccountAPIService.API> {
    readonly name: string;
    readonly dependencies: any;
    services: ServiceSpec.AllServices;
    constructor();
}
